/***************************************************************************
                          example.cpp  -  description
                             -------------------
    begin                : Thu Sep  4 17:24:09 MSD 2003
    copyright            : (C) 2003 by Soloviev Alexei,JINR,LIT-303,64713
    email                : solovjev@cv.jinr.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cmath>
using namespace std;

#include <histogram>
#include <hplot>
using namespace htl;

int main ( int argc, char** argv )
{
  cout<<"#### Example 1 ####"<<endl;

  domain<double> axis(M_PI,2*M_PI,128);
  histogram<double,double> h1(axis), h2(axis);

  for ( double x = axis.min(); x < axis.max(); x += 0.001 ) {
    h1(x) = sin(x);
    h2(x) = sin(8*x);
  }

  h1 *= -2.;
  histogram<double,double> h = h1 * h2;
  h = abs ( h );

  cout<<"Sinus:"<<endl;
  cout<<"Mean = "<<mean(h)<<endl;
  cout<<"RMS = "<<rms(h)<<endl;

  domain<double> axis2(-2,2,128);
  histogram<double,double> g1(axis2), g2(axis2);

  for ( double x = axis2.min(); x < axis2.max(); x+=0.001 ) {
    g1(x) = exp(-x*x/0.2);
    g2(x) = exp(-(x-1)*(x-1)/0.2);
  }

  histogram<double,double> g = 2. * g1 + g2;

  cout<<"Gauss:"<<endl;
  cout<<"Mean = "<<mean(g)<<endl;
  cout<<"RMS = "<<rms(g)<<endl;

  hplot pout;
  pout<<h1<<h2<<h;
  pout<<g1<<g2<<g;

  return 0;
}
