/***************************************************************************
                          example.cpp  -  description
                             -------------------
    begin                : Thu Sep  4 17:24:09 MSD 2003
    copyright            : (C) 2003 by Soloviev Alexei,JINR,LIT-303,64713
    email                : solovjev@cv.jinr.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cmath>
using namespace std;

#include <histogram>
#include <hplot>
using namespace htl;

int main(int argc, char** argv)
{
  cout<<"#### Example 2 ####"<<endl;

  domain<double> axis(-2,2,128);
  histogram<double,double> g1(axis), g2(axis);

  for ( double x = axis.min(); x < axis.max(); x+=0.001 ) {
    g1(x) = exp(-x*x/0.2);
    g2(x) = exp(-(x-1)*(x-1)/0.2);
  }

  histogram<double,double> g = 2. * g1 + g2;

  cout<<"Gauss:"<<endl;
  cout<<"Mean = "<<mean(g)<<endl;
  cout<<"RMS = "<<rms(g)<<endl;

  hplot pout ("Gaussians");
  pout<<contour::linespoints<<g1
      <<contour::boxes<<g2
      <<contour::steps<<g;
  pout.set_title("Example of plot styles").set_x_label("x-label").set_y_label("y-label");

  return 0;
}
