/***************************************************************************
                          htl_text_label.h  -  description
                             -------------------
    begin                : Sun Oct 5 2003
    copyright            : (C) 2003 by Soloviev Alexei,JINR,LIT-303,64713
    email                : solovjev@cv.jinr.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HTL_TEXT_LABEL_H
#define HTL_TEXT_LABEL_H

#include <string>
using namespace std;

namespace htl {

class text_label {
public: 
  explicit text_label ( const string & text = "" );
  virtual ~text_label() {}

public: 
  const string & text() const { return _text; }
  string & text() { return _text; }

public: 
  const double & x() const { return _x; }
  double & x()  { return _x; }
  const double & y() const { return _y; }
  double & y()  { return _y; }

public: 
  enum X_ALIGNMENT { left = 0,
		     right = 2,
		     center = 1 };
  enum Y_ALIGNMENT { bottom = 0,
		     top = 2,
		     middle = 1 };

  void set_x_alignment ( X_ALIGNMENT align ) { _x_alignment = align; }
  void set_y_alignment ( Y_ALIGNMENT align ) { _y_alignment = align; }

public: 
  virtual void plot() const;

protected:
  string _text;
  double _x, _y;
  void * _font;

protected:
  string _gl2ps_fontname;
  int _gl2ps_fontsize;

protected:
  X_ALIGNMENT _x_alignment;
  Y_ALIGNMENT _y_alignment;
  mutable double _x_offset, _y_offset;
};

class title : public text_label {
public:
  explicit title ( const string & text = "" );
  virtual ~title() {}

  virtual void plot() const;
};

class x_label : public text_label {
public:
  explicit x_label ( const string & text = "" );
  virtual ~x_label() {}

  virtual void plot() const;
};

class y_label : public text_label {
public:
  explicit y_label ( const string & text = "" );
  virtual ~y_label() {}

  virtual void plot() const;
};

} /** namespace htl */

#endif /* HTL_TEXT_LABEL_H */

// Local Variables:
// mode:C++
// End:
